package dev.pfaff.glass;

import org.jspecify.annotations.NonNull;
import org.jspecify.annotations.Nullable;

import java.lang.foreign.MemorySegment;

/**
 * {@link java.lang.foreign.SymbolLookup} using nullable types instead of {@link java.util.Optional}.
 *
 * @see java.lang.foreign.SymbolLookup
 */
@FunctionalInterface
public interface SymbolLookup {
	/**
	 * @return the address of the symbol if found, otherwise {@code null}.
	 */
	@Nullable
	MemorySegment find(@NonNull String name);
}
